[arch-commits] Commit in systemd/repos (12 files)

Dave Reisner dreisner at nymeria.archlinux.org
Tue Jul 23 13:45:45 UTC 2013


    Date: Tuesday, July 23, 2013 @ 15:45:44
  Author: dreisner
Revision: 191314

archrelease: copy trunk to testing-i686, testing-x86_64

Added:
  systemd/repos/testing-i686/
  systemd/repos/testing-i686/PKGBUILD
    (from rev 191313, systemd/trunk/PKGBUILD)
  systemd/repos/testing-i686/initcpio-hook-udev
    (from rev 191313, systemd/trunk/initcpio-hook-udev)
  systemd/repos/testing-i686/initcpio-install-systemd
    (from rev 191313, systemd/trunk/initcpio-install-systemd)
  systemd/repos/testing-i686/initcpio-install-udev
    (from rev 191313, systemd/trunk/initcpio-install-udev)
  systemd/repos/testing-i686/systemd.install
    (from rev 191313, systemd/trunk/systemd.install)
  systemd/repos/testing-x86_64/
  systemd/repos/testing-x86_64/PKGBUILD
    (from rev 191313, systemd/trunk/PKGBUILD)
  systemd/repos/testing-x86_64/initcpio-hook-udev
    (from rev 191313, systemd/trunk/initcpio-hook-udev)
  systemd/repos/testing-x86_64/initcpio-install-systemd
    (from rev 191313, systemd/trunk/initcpio-install-systemd)
  systemd/repos/testing-x86_64/initcpio-install-udev
    (from rev 191313, systemd/trunk/initcpio-install-udev)
  systemd/repos/testing-x86_64/systemd.install
    (from rev 191313, systemd/trunk/systemd.install)

-----------------------------------------+
 testing-i686/PKGBUILD                   |  127 ++++++++++++++++++++++++
 testing-i686/initcpio-hook-udev         |   20 +++
 testing-i686/initcpio-install-systemd   |  153 ++++++++++++++++++++++++++++++
 testing-i686/initcpio-install-udev      |   28 +++++
 testing-i686/systemd.install            |  103 ++++++++++++++++++++
 testing-x86_64/PKGBUILD                 |  127 ++++++++++++++++++++++++
 testing-x86_64/initcpio-hook-udev       |   20 +++
 testing-x86_64/initcpio-install-systemd |  153 ++++++++++++++++++++++++++++++
 testing-x86_64/initcpio-install-udev    |   28 +++++
 testing-x86_64/systemd.install          |  103 ++++++++++++++++++++
 10 files changed, 862 insertions(+)

Copied: systemd/repos/testing-i686/PKGBUILD (from rev 191313, systemd/trunk/PKGBUILD)
===================================================================
--- testing-i686/PKGBUILD	                        (rev 0)
+++ testing-i686/PKGBUILD	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,127 @@
+# Maintainer: Dave Reisner <dreisner at archlinux.org>
+# Maintainer: Tom Gundersen <teg at jklm.no>
+
+pkgbase=systemd
+pkgname=('systemd' 'systemd-sysvcompat')
+pkgver=206
+pkgrel=1
+arch=('i686' 'x86_64')
+url="http://www.freedesktop.org/wiki/Software/systemd"
+license=('GPL2' 'LGPL2.1' 'MIT')
+makedepends=('acl' 'cryptsetup' 'dbus-core' 'docbook-xsl' 'gobject-introspection' 'gperf'
+             'gtk-doc' 'intltool' 'kmod' 'libcap' 'libgcrypt'  'libmicrohttpd' 'libxslt'
+             'linux-api-headers' 'pam' 'python' 'quota-tools' 'xz')
+options=('!libtool')
+source=("http://www.freedesktop.org/software/$pkgname/$pkgname-$pkgver.tar.xz"
+        'initcpio-hook-udev'
+        'initcpio-install-systemd'
+        'initcpio-install-udev')
+md5sums=('89e36f2d3ba963020b72738549954cbc'
+         '2de72238ed5c0df62a7c3b6bdaf8cb7c'
+         'ee6565a05be172de8f12e0a139ba8df4'
+         'd83d45e67cd75cdbafb81c96a7485319')
+
+build() {
+  cd "$pkgname-$pkgver"
+
+  ./configure \
+      --libexecdir=/usr/lib \
+      --localstatedir=/var \
+      --sysconfdir=/etc \
+      --enable-introspection \
+      --enable-gtk-doc \
+      --disable-audit \
+      --disable-ima \
+      --with-sysvinit-path= \
+      --with-sysvrcnd-path= \
+      --with-firmware-path="/usr/lib/firmware/updates:/usr/lib/firmware"
+
+  make
+}
+
+check() {
+  # two tests fail due to running under nspawn
+  make -C "$pkgname-$pkgver" check || true
+}
+
+package_systemd() {
+  pkgdesc="system and service manager"
+  depends=('acl' 'bash' 'dbus-core' 'glib2' 'kbd' 'kmod' 'hwids' 'libcap' 'libgcrypt'
+           'pam' 'util-linux' 'xz')
+  provides=("libsystemd=$pkgver" 'nss-myhostname' "systemd-tools=$pkgver" "udev=$pkgver"
+            'libgudev-1.0.so' 'libsystemd-daemon.so' 'libsystemd-id128.so'
+            'libsystemd-journal.so' 'libsystemd-login.so' 'libudev.so')
+  replaces=('libsystemd' 'nss-myhostname' 'systemd-tools' 'udev')
+  conflicts=('libsystemd' 'nss-myhostname' 'systemd-tools' 'udev')
+  optdepends=('cryptsetup: required for encrypted block devices'
+              'libmicrohttpd: systemd-journal-gatewayd'
+              'quota-tools: kernel-level quota management'
+              'python: systemd library bindings'
+              'systemd-sysvcompat: symlink package to provide sysvinit binaries')
+  backup=(etc/dbus-1/system.d/org.freedesktop.systemd1.conf
+          etc/dbus-1/system.d/org.freedesktop.hostname1.conf
+          etc/dbus-1/system.d/org.freedesktop.login1.conf
+          etc/dbus-1/system.d/org.freedesktop.locale1.conf
+          etc/dbus-1/system.d/org.freedesktop.machine1.conf
+          etc/dbus-1/system.d/org.freedesktop.timedate1.conf
+          etc/systemd/bootchart.conf
+          etc/systemd/journald.conf
+          etc/systemd/logind.conf
+          etc/systemd/system.conf
+          etc/systemd/user.conf
+          etc/udev/udev.conf)
+  install="systemd.install"
+
+  make -C "$pkgname-$pkgver" DESTDIR="$pkgdir" install
+
+  printf "d /run/console 0755 root root\n" > "$pkgdir/usr/lib/tmpfiles.d/console.conf"
+
+  # fix .so links in manpage stubs
+  find "$pkgdir/usr/share/man" -type f -name '*.[[:digit:]]' \
+      -exec sed -ri '1s|^\.so (.*)\.([0-9]+)|.so man\2/\1.\2|' {} +
+
+  # don't write units to /etc by default -- we'll enable this on post_install
+  # as a sane default
+  rm "$pkgdir/etc/systemd/system/getty.target.wants/getty at tty1.service"
+  rmdir "$pkgdir/etc/systemd/system/getty.target.wants"
+
+  # get rid of RPM macros
+  rm -r "$pkgdir/usr/lib/rpm/macros.d"
+
+  # add back tmpfiles.d/legacy.conf
+  install -m644 "systemd-$pkgver/tmpfiles.d/legacy.conf" "$pkgdir/usr/lib/tmpfiles.d"
+
+  # Replace dialout/tape/cdrom group in rules with uucp/storage/optical group
+  sed -i 's#GROUP="dialout"#GROUP="uucp"#g;
+          s#GROUP="tape"#GROUP="storage"#g;
+          s#GROUP="cdrom"#GROUP="optical"#g' "$pkgdir"/usr/lib/udev/rules.d/*.rules
+
+  # add mkinitcpio hooks
+  install -Dm644 "$srcdir/initcpio-install-systemd" "$pkgdir/usr/lib/initcpio/install/systemd"
+  install -Dm644 "$srcdir/initcpio-install-udev" "$pkgdir/usr/lib/initcpio/install/udev"
+  install -Dm644 "$srcdir/initcpio-hook-udev" "$pkgdir/usr/lib/initcpio/hooks/udev"
+
+  ### split out manpages for sysvcompat
+  rm -rf "$srcdir/_sysvcompat"
+  install -dm755 "$srcdir"/_sysvcompat/usr/share/man/man8/
+  mv "$pkgdir"/usr/share/man/man8/{telinit,halt,reboot,poweroff,runlevel,shutdown}.8 \
+     "$srcdir"/_sysvcompat/usr/share/man/man8
+}
+
+package_systemd-sysvcompat() {
+  pkgdesc="sysvinit compat for systemd"
+  groups=('base')
+  conflicts=('sysvinit')
+  depends=('sysvinit-tools' 'systemd')
+
+  mv "$srcdir/_sysvcompat"/* "$pkgdir"
+
+  install -dm755 "$pkgdir/usr/bin"
+  for tool in runlevel reboot shutdown poweroff halt telinit; do
+    ln -s 'systemctl' "$pkgdir/usr/bin/$tool"
+  done
+
+  ln -s '../lib/systemd/systemd' "$pkgdir/usr/bin/init"
+}
+
+# vim: ft=sh syn=sh et

Copied: systemd/repos/testing-i686/initcpio-hook-udev (from rev 191313, systemd/trunk/initcpio-hook-udev)
===================================================================
--- testing-i686/initcpio-hook-udev	                        (rev 0)
+++ testing-i686/initcpio-hook-udev	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,20 @@
+#!/usr/bin/ash
+
+run_earlyhook() {
+    /usr/lib/systemd/systemd-udevd --daemon --resolve-names=never
+    udevd_running=1
+}
+
+run_hook() {
+    msg ":: Triggering uevents..."
+    udevadm trigger --action=add --type=subsystems
+    udevadm trigger --action=add --type=devices
+    udevadm settle
+}
+
+run_cleanuphook() {
+    udevadm control --exit
+    udevadm info --cleanup-db
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-i686/initcpio-install-systemd (from rev 191313, systemd/trunk/initcpio-install-systemd)
===================================================================
--- testing-i686/initcpio-install-systemd	                        (rev 0)
+++ testing-i686/initcpio-install-systemd	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,153 @@
+#!/bin/bash
+
+strip_quotes() {
+  local len=${#1} quotes=$'[\'"]' str=${!1}
+
+  if [[ ${str:0:1} = ${str: -1} && ${str:0:1} = $quotes ]]; then
+    declare -g "$1=${str:1:-1}"
+  fi
+}
+
+add_udev_rule() {
+    # Add an udev rules file to the initcpio image. Dependencies on binaries
+    # will be discovered and added.
+    #   $1: path to rules file (or name of rules file)
+
+    local rules= rule= key= value= binary=
+
+    rules=$(PATH=/usr/lib/udev/rules.d:/lib/udev/rules.d type -P "$1")
+    if [[ -z $rules ]]; then
+        # complain about not found rules
+        return 1
+    fi
+
+    add_file "$rules"
+
+    while IFS=, read -ra rule; do
+        for pair in "${rule[@]}"; do
+            IFS=' =' read -r key value <<< "$pair"
+            strip_quotes 'value'
+            case $key in
+                RUN@({program}|+)|IMPORT{program}|ENV{REMOVE_CMD})
+                    # just take the first word as the binary name
+                    binary=${value%% *}
+                    if [[ ${binary:0:1} != '/' ]]; then
+                        binary=$(PATH=/usr/lib/udev:/lib/udev type -P "$binary")
+                    fi
+                    add_binary "$binary"
+                    ;;
+            esac
+        done
+    done <"$rules"
+}
+
+add_systemd_unit() {
+    # Add a systemd unit file to the initcpio image. Hard dependencies on binaries
+    # and other unit files will be discovered and added.
+    #   $1: path to rules file (or name of rules file)
+
+    local unit= rule= entry= key= value= binary= dep=
+
+    unit=$(PATH=/usr/lib/systemd/system:/lib/systemd/system type -P "$1")
+    if [[ -z $unit ]]; then
+        # complain about not found unit file
+        return 1
+    fi
+
+    add_file "$unit"
+
+    while IFS='=' read -r key values; do
+        read -ra values <<< "$values"
+
+        case $key in
+            Requires|OnFailure)
+                # only add hard dependencies (not Wants)
+                map add_systemd_unit "${values[@]}"
+                ;;
+            Exec*)
+                # don't add binaries unless they are required
+                if [[ ${values[0]:0:1} != '-' ]]; then
+                    add_binary "${values[0]}"
+                fi
+                ;;
+        esac
+
+    done <"$unit"
+
+    # preserve reverse soft dependency
+    for dep in {/usr,}/lib/systemd/system/*.wants/${unit##*/}; do
+        if [[ -L $dep ]]; then
+            add_symlink "$dep"
+        fi
+    done
+
+    # add hard dependencies
+    if [[ -d $unit.requires ]]; then
+        for dep in "$unit".requires/*; do
+            add_systemd_unit ${dep##*/}
+        done
+    fi
+}
+
+build() {
+    local rules unit
+
+    # from base
+    add_binary /bin/mount
+    add_binary /usr/bin/kmod /usr/bin/modprobe
+
+    # systemd
+    add_binary /usr/lib/systemd/systemd /init
+
+    # generate sysroot.mount and sysroot-usr.mount
+    add_file "/usr/lib/systemd/system-generators/systemd-fstab-generator"
+
+    # udev rules and systemd units
+    map add_udev_rule "$rules" \
+            50-udev-default.rules \
+            60-persistent-storage.rules \
+            64-btrfs.rules \
+            80-drivers.rules \
+            99-systemd.rules \
+
+    map add_systemd_unit \
+            systemd-udevd-control.socket \
+            systemd-udevd-kernel.socket \
+            sockets.target \
+            systemd-journald.service \
+            systemd-udevd.service \
+            systemd-udev-trigger.service \
+            initrd-cleanup.service \
+            initrd-fs.target \
+            initrd-parse-etc.service \
+            initrd-root-fs.target \
+            initrd-switch-root.service \
+            initrd-switch-root.target \
+            initrd-udevadm-cleanup-db.service \
+            initrd.target \
+            systemd-fsck at .service \
+            ctrl-alt-del.target
+
+    add_symlink "/usr/lib/systemd/system/default.target" "initrd.target"
+
+    # libdbus needs the passwd info of the root user
+    # TODO: make sure this is no longer necessary when systemctl moves to sd-bus
+    add_file "/etc/nsswitch.conf"
+    add_file "/etc/passwd"
+    add_binary "/lib/libnss_files-2.17.so"
+
+    # udev wants /etc/group since it doesn't launch with --resolve-names=never
+    add_file "/etc/group"
+}
+
+help() {
+    cat <<HELPEOF
+This will install a basic systemd setup in your initramfs, and is meant to
+replace the 'base', 'usr', 'udev' and 'timestamp' hooks. Other hooks would need
+to be ported, and may not work as intended. You also may wish to still include
+the 'base' hook (before this hook) to ensure that a rescue shell exists on your
+initramfs.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-i686/initcpio-install-udev (from rev 191313, systemd/trunk/initcpio-install-udev)
===================================================================
--- testing-i686/initcpio-install-udev	                        (rev 0)
+++ testing-i686/initcpio-install-udev	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,28 @@
+#!/bin/bash
+
+build() {
+    local rules tool
+
+    add_file "/etc/udev/udev.conf"
+    add_binary /usr/lib/systemd/systemd-udevd
+    add_binary /usr/bin/udevadm
+
+    for rules in 50-udev-default.rules 60-persistent-storage.rules 64-btrfs.rules 80-drivers.rules; do
+        add_file "/usr/lib/udev/rules.d/$rules"
+    done
+    for tool in ata_id scsi_id; do
+        add_file "/usr/lib/udev/$tool"
+    done
+
+    add_runscript
+}
+
+help() {
+    cat <<HELPEOF
+This hook will use udev to create your root device node and detect the needed
+modules for your root device. It is also required for firmware loading in
+initramfs. It is recommended to use this hook.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-i686/systemd.install (from rev 191313, systemd/trunk/systemd.install)
===================================================================
--- testing-i686/systemd.install	                        (rev 0)
+++ testing-i686/systemd.install	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,103 @@
+#!/bin/sh
+
+sd_booted() {
+  [ -e sys/fs/cgroup/systemd ]
+}
+
+add_privs() {
+  if ! setcap "$2" "$1" 2>/dev/null; then
+    echo "==> Warning: setcap failed, falling back to setuid root on /$1"
+    chmod u+s "$1"
+  fi
+}
+
+post_common() {
+  systemd-machine-id-setup
+
+  add_privs usr/bin/systemd-detect-virt 'cap_dac_override,cap_sys_ptrace+ep'
+
+  udevadm hwdb --update
+  journalctl --update-catalog
+
+  if sd_booted; then
+    systemctl --system daemon-reexec
+  fi
+}
+
+mask_net_naming() {
+  if [ ! -e etc/udev/rules.d/80-net-name-slot.rules ]; then
+    printf >etc/udev/rules.d/80-net-name-slot.rules '# %s\n' \
+      "This file masks persistent renaming rules for network devices. If you" \
+      "delete this file, /usr/lib/udev/rules.d/80-net-name-slot.rules may" \
+      "rename network devices according to ID_NET_NAME_{ONBOARD,SLOT,PATH}" \
+      "properties of your network devices, with priority in that order. See" \
+      "the output of 'udevadm test-builtin net_id /sys/class/net/\$interface'" \
+      "for details on what that new name might be." \
+      "" \
+      "http://www.freedesktop.org/wiki/Software/systemd/PredictableNetworkInterfaceNames"
+  fi
+}
+
+post_install() {
+  post_common
+
+  # enable getty at tty1 by default, but don't track the file
+  systemctl enable getty at .service
+
+  echo ":: Append 'init=/usr/lib/systemd/systemd' to your kernel command line in your"
+  echo "   bootloader to replace sysvinit with systemd, or install systemd-sysvcompat"
+}
+
+post_upgrade() {
+  post_common
+
+  # getty at tty1.service is no longer enabled by default, but we don't want to break
+  # existing setups.
+  if [ "$(vercmp 183 "$2")" -eq 1 ]; then
+    # systemctl seems to be whiny on sysvinit. this will succeed unless something
+    # horrific happens, so just mask the error.
+    systemctl -q enable getty at .service || true
+  fi
+
+  if [ "$(vercmp 194-4 "$2")" -eq 1 ]; then
+    printf '==> journald now writes to /var/log/journal by default. This can be\n'
+    printf '    controlled with the Storage setting in /etc/systemd/journald.conf\n'
+  fi
+
+  # logind's protocol changed. kindly restart the daemon to avoid locking
+  # out further logins.
+  if [ "$(vercmp 195 "$2")" -eq 1 ]; then
+    if sd_booted; then
+      systemctl restart systemd-logind.service
+    fi
+  fi
+
+  if [ "$(vercmp 196-1 "$2")" -eq 1 ]; then
+    printf '==> The legacy configuration options are no longer supported in rc.conf,\n'
+    printf '    convert your rc.conf to the new configuration formats.\n'
+  fi
+
+  if [ "$(vercmp 197-1 "$2")" -eq 1 ]; then
+    mask_net_naming
+    printf '==> Persistent net naming rules have been shipped as disabled.\n'
+    printf '    See /etc/udev/rules.d/80-net-name-slot.rules for more detail\n'
+  fi
+
+  if [ "$(vercmp 204-1 "$2")" -eq 1 ]; then
+    printf '==> The /bin/systemd symlink has been removed. Any references in your\n'
+    printf '    bootloader (or elsewhere) must be updated to /usr/lib/systemd/systemd.\n'
+  fi
+
+  if [ "$(vercmp 205-1 "$2")" -eq 1 ]; then
+    printf '==> systemd 205 restructures the cgroup hierarchy and changes internal\n'
+    printf '    protocols. You should reboot at your earliest convenience.\n'
+  fi
+
+  if [ "$(vercmp 206-1 "$2")" -eq 1 ]; then
+    printf '==> The "timestamp" hook for mkinitcpio no longer exists. If you used\n'
+    printf '    this hook, you must remove it from /etc/mkinitcpio.conf. A "systemd"\n'
+    printf '    hook has been added which provides this functionality, and more.\n'
+  fi
+}
+
+# vim:set ts=2 sw=2 et:

Copied: systemd/repos/testing-x86_64/PKGBUILD (from rev 191313, systemd/trunk/PKGBUILD)
===================================================================
--- testing-x86_64/PKGBUILD	                        (rev 0)
+++ testing-x86_64/PKGBUILD	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,127 @@
+# Maintainer: Dave Reisner <dreisner at archlinux.org>
+# Maintainer: Tom Gundersen <teg at jklm.no>
+
+pkgbase=systemd
+pkgname=('systemd' 'systemd-sysvcompat')
+pkgver=206
+pkgrel=1
+arch=('i686' 'x86_64')
+url="http://www.freedesktop.org/wiki/Software/systemd"
+license=('GPL2' 'LGPL2.1' 'MIT')
+makedepends=('acl' 'cryptsetup' 'dbus-core' 'docbook-xsl' 'gobject-introspection' 'gperf'
+             'gtk-doc' 'intltool' 'kmod' 'libcap' 'libgcrypt'  'libmicrohttpd' 'libxslt'
+             'linux-api-headers' 'pam' 'python' 'quota-tools' 'xz')
+options=('!libtool')
+source=("http://www.freedesktop.org/software/$pkgname/$pkgname-$pkgver.tar.xz"
+        'initcpio-hook-udev'
+        'initcpio-install-systemd'
+        'initcpio-install-udev')
+md5sums=('89e36f2d3ba963020b72738549954cbc'
+         '2de72238ed5c0df62a7c3b6bdaf8cb7c'
+         'ee6565a05be172de8f12e0a139ba8df4'
+         'd83d45e67cd75cdbafb81c96a7485319')
+
+build() {
+  cd "$pkgname-$pkgver"
+
+  ./configure \
+      --libexecdir=/usr/lib \
+      --localstatedir=/var \
+      --sysconfdir=/etc \
+      --enable-introspection \
+      --enable-gtk-doc \
+      --disable-audit \
+      --disable-ima \
+      --with-sysvinit-path= \
+      --with-sysvrcnd-path= \
+      --with-firmware-path="/usr/lib/firmware/updates:/usr/lib/firmware"
+
+  make
+}
+
+check() {
+  # two tests fail due to running under nspawn
+  make -C "$pkgname-$pkgver" check || true
+}
+
+package_systemd() {
+  pkgdesc="system and service manager"
+  depends=('acl' 'bash' 'dbus-core' 'glib2' 'kbd' 'kmod' 'hwids' 'libcap' 'libgcrypt'
+           'pam' 'util-linux' 'xz')
+  provides=("libsystemd=$pkgver" 'nss-myhostname' "systemd-tools=$pkgver" "udev=$pkgver"
+            'libgudev-1.0.so' 'libsystemd-daemon.so' 'libsystemd-id128.so'
+            'libsystemd-journal.so' 'libsystemd-login.so' 'libudev.so')
+  replaces=('libsystemd' 'nss-myhostname' 'systemd-tools' 'udev')
+  conflicts=('libsystemd' 'nss-myhostname' 'systemd-tools' 'udev')
+  optdepends=('cryptsetup: required for encrypted block devices'
+              'libmicrohttpd: systemd-journal-gatewayd'
+              'quota-tools: kernel-level quota management'
+              'python: systemd library bindings'
+              'systemd-sysvcompat: symlink package to provide sysvinit binaries')
+  backup=(etc/dbus-1/system.d/org.freedesktop.systemd1.conf
+          etc/dbus-1/system.d/org.freedesktop.hostname1.conf
+          etc/dbus-1/system.d/org.freedesktop.login1.conf
+          etc/dbus-1/system.d/org.freedesktop.locale1.conf
+          etc/dbus-1/system.d/org.freedesktop.machine1.conf
+          etc/dbus-1/system.d/org.freedesktop.timedate1.conf
+          etc/systemd/bootchart.conf
+          etc/systemd/journald.conf
+          etc/systemd/logind.conf
+          etc/systemd/system.conf
+          etc/systemd/user.conf
+          etc/udev/udev.conf)
+  install="systemd.install"
+
+  make -C "$pkgname-$pkgver" DESTDIR="$pkgdir" install
+
+  printf "d /run/console 0755 root root\n" > "$pkgdir/usr/lib/tmpfiles.d/console.conf"
+
+  # fix .so links in manpage stubs
+  find "$pkgdir/usr/share/man" -type f -name '*.[[:digit:]]' \
+      -exec sed -ri '1s|^\.so (.*)\.([0-9]+)|.so man\2/\1.\2|' {} +
+
+  # don't write units to /etc by default -- we'll enable this on post_install
+  # as a sane default
+  rm "$pkgdir/etc/systemd/system/getty.target.wants/getty at tty1.service"
+  rmdir "$pkgdir/etc/systemd/system/getty.target.wants"
+
+  # get rid of RPM macros
+  rm -r "$pkgdir/usr/lib/rpm/macros.d"
+
+  # add back tmpfiles.d/legacy.conf
+  install -m644 "systemd-$pkgver/tmpfiles.d/legacy.conf" "$pkgdir/usr/lib/tmpfiles.d"
+
+  # Replace dialout/tape/cdrom group in rules with uucp/storage/optical group
+  sed -i 's#GROUP="dialout"#GROUP="uucp"#g;
+          s#GROUP="tape"#GROUP="storage"#g;
+          s#GROUP="cdrom"#GROUP="optical"#g' "$pkgdir"/usr/lib/udev/rules.d/*.rules
+
+  # add mkinitcpio hooks
+  install -Dm644 "$srcdir/initcpio-install-systemd" "$pkgdir/usr/lib/initcpio/install/systemd"
+  install -Dm644 "$srcdir/initcpio-install-udev" "$pkgdir/usr/lib/initcpio/install/udev"
+  install -Dm644 "$srcdir/initcpio-hook-udev" "$pkgdir/usr/lib/initcpio/hooks/udev"
+
+  ### split out manpages for sysvcompat
+  rm -rf "$srcdir/_sysvcompat"
+  install -dm755 "$srcdir"/_sysvcompat/usr/share/man/man8/
+  mv "$pkgdir"/usr/share/man/man8/{telinit,halt,reboot,poweroff,runlevel,shutdown}.8 \
+     "$srcdir"/_sysvcompat/usr/share/man/man8
+}
+
+package_systemd-sysvcompat() {
+  pkgdesc="sysvinit compat for systemd"
+  groups=('base')
+  conflicts=('sysvinit')
+  depends=('sysvinit-tools' 'systemd')
+
+  mv "$srcdir/_sysvcompat"/* "$pkgdir"
+
+  install -dm755 "$pkgdir/usr/bin"
+  for tool in runlevel reboot shutdown poweroff halt telinit; do
+    ln -s 'systemctl' "$pkgdir/usr/bin/$tool"
+  done
+
+  ln -s '../lib/systemd/systemd' "$pkgdir/usr/bin/init"
+}
+
+# vim: ft=sh syn=sh et

Copied: systemd/repos/testing-x86_64/initcpio-hook-udev (from rev 191313, systemd/trunk/initcpio-hook-udev)
===================================================================
--- testing-x86_64/initcpio-hook-udev	                        (rev 0)
+++ testing-x86_64/initcpio-hook-udev	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,20 @@
+#!/usr/bin/ash
+
+run_earlyhook() {
+    /usr/lib/systemd/systemd-udevd --daemon --resolve-names=never
+    udevd_running=1
+}
+
+run_hook() {
+    msg ":: Triggering uevents..."
+    udevadm trigger --action=add --type=subsystems
+    udevadm trigger --action=add --type=devices
+    udevadm settle
+}
+
+run_cleanuphook() {
+    udevadm control --exit
+    udevadm info --cleanup-db
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-x86_64/initcpio-install-systemd (from rev 191313, systemd/trunk/initcpio-install-systemd)
===================================================================
--- testing-x86_64/initcpio-install-systemd	                        (rev 0)
+++ testing-x86_64/initcpio-install-systemd	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,153 @@
+#!/bin/bash
+
+strip_quotes() {
+  local len=${#1} quotes=$'[\'"]' str=${!1}
+
+  if [[ ${str:0:1} = ${str: -1} && ${str:0:1} = $quotes ]]; then
+    declare -g "$1=${str:1:-1}"
+  fi
+}
+
+add_udev_rule() {
+    # Add an udev rules file to the initcpio image. Dependencies on binaries
+    # will be discovered and added.
+    #   $1: path to rules file (or name of rules file)
+
+    local rules= rule= key= value= binary=
+
+    rules=$(PATH=/usr/lib/udev/rules.d:/lib/udev/rules.d type -P "$1")
+    if [[ -z $rules ]]; then
+        # complain about not found rules
+        return 1
+    fi
+
+    add_file "$rules"
+
+    while IFS=, read -ra rule; do
+        for pair in "${rule[@]}"; do
+            IFS=' =' read -r key value <<< "$pair"
+            strip_quotes 'value'
+            case $key in
+                RUN@({program}|+)|IMPORT{program}|ENV{REMOVE_CMD})
+                    # just take the first word as the binary name
+                    binary=${value%% *}
+                    if [[ ${binary:0:1} != '/' ]]; then
+                        binary=$(PATH=/usr/lib/udev:/lib/udev type -P "$binary")
+                    fi
+                    add_binary "$binary"
+                    ;;
+            esac
+        done
+    done <"$rules"
+}
+
+add_systemd_unit() {
+    # Add a systemd unit file to the initcpio image. Hard dependencies on binaries
+    # and other unit files will be discovered and added.
+    #   $1: path to rules file (or name of rules file)
+
+    local unit= rule= entry= key= value= binary= dep=
+
+    unit=$(PATH=/usr/lib/systemd/system:/lib/systemd/system type -P "$1")
+    if [[ -z $unit ]]; then
+        # complain about not found unit file
+        return 1
+    fi
+
+    add_file "$unit"
+
+    while IFS='=' read -r key values; do
+        read -ra values <<< "$values"
+
+        case $key in
+            Requires|OnFailure)
+                # only add hard dependencies (not Wants)
+                map add_systemd_unit "${values[@]}"
+                ;;
+            Exec*)
+                # don't add binaries unless they are required
+                if [[ ${values[0]:0:1} != '-' ]]; then
+                    add_binary "${values[0]}"
+                fi
+                ;;
+        esac
+
+    done <"$unit"
+
+    # preserve reverse soft dependency
+    for dep in {/usr,}/lib/systemd/system/*.wants/${unit##*/}; do
+        if [[ -L $dep ]]; then
+            add_symlink "$dep"
+        fi
+    done
+
+    # add hard dependencies
+    if [[ -d $unit.requires ]]; then
+        for dep in "$unit".requires/*; do
+            add_systemd_unit ${dep##*/}
+        done
+    fi
+}
+
+build() {
+    local rules unit
+
+    # from base
+    add_binary /bin/mount
+    add_binary /usr/bin/kmod /usr/bin/modprobe
+
+    # systemd
+    add_binary /usr/lib/systemd/systemd /init
+
+    # generate sysroot.mount and sysroot-usr.mount
+    add_file "/usr/lib/systemd/system-generators/systemd-fstab-generator"
+
+    # udev rules and systemd units
+    map add_udev_rule "$rules" \
+            50-udev-default.rules \
+            60-persistent-storage.rules \
+            64-btrfs.rules \
+            80-drivers.rules \
+            99-systemd.rules \
+
+    map add_systemd_unit \
+            systemd-udevd-control.socket \
+            systemd-udevd-kernel.socket \
+            sockets.target \
+            systemd-journald.service \
+            systemd-udevd.service \
+            systemd-udev-trigger.service \
+            initrd-cleanup.service \
+            initrd-fs.target \
+            initrd-parse-etc.service \
+            initrd-root-fs.target \
+            initrd-switch-root.service \
+            initrd-switch-root.target \
+            initrd-udevadm-cleanup-db.service \
+            initrd.target \
+            systemd-fsck at .service \
+            ctrl-alt-del.target
+
+    add_symlink "/usr/lib/systemd/system/default.target" "initrd.target"
+
+    # libdbus needs the passwd info of the root user
+    # TODO: make sure this is no longer necessary when systemctl moves to sd-bus
+    add_file "/etc/nsswitch.conf"
+    add_file "/etc/passwd"
+    add_binary "/lib/libnss_files-2.17.so"
+
+    # udev wants /etc/group since it doesn't launch with --resolve-names=never
+    add_file "/etc/group"
+}
+
+help() {
+    cat <<HELPEOF
+This will install a basic systemd setup in your initramfs, and is meant to
+replace the 'base', 'usr', 'udev' and 'timestamp' hooks. Other hooks would need
+to be ported, and may not work as intended. You also may wish to still include
+the 'base' hook (before this hook) to ensure that a rescue shell exists on your
+initramfs.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-x86_64/initcpio-install-udev (from rev 191313, systemd/trunk/initcpio-install-udev)
===================================================================
--- testing-x86_64/initcpio-install-udev	                        (rev 0)
+++ testing-x86_64/initcpio-install-udev	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,28 @@
+#!/bin/bash
+
+build() {
+    local rules tool
+
+    add_file "/etc/udev/udev.conf"
+    add_binary /usr/lib/systemd/systemd-udevd
+    add_binary /usr/bin/udevadm
+
+    for rules in 50-udev-default.rules 60-persistent-storage.rules 64-btrfs.rules 80-drivers.rules; do
+        add_file "/usr/lib/udev/rules.d/$rules"
+    done
+    for tool in ata_id scsi_id; do
+        add_file "/usr/lib/udev/$tool"
+    done
+
+    add_runscript
+}
+
+help() {
+    cat <<HELPEOF
+This hook will use udev to create your root device node and detect the needed
+modules for your root device. It is also required for firmware loading in
+initramfs. It is recommended to use this hook.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:

Copied: systemd/repos/testing-x86_64/systemd.install (from rev 191313, systemd/trunk/systemd.install)
===================================================================
--- testing-x86_64/systemd.install	                        (rev 0)
+++ testing-x86_64/systemd.install	2013-07-23 13:45:44 UTC (rev 191314)
@@ -0,0 +1,103 @@
+#!/bin/sh
+
+sd_booted() {
+  [ -e sys/fs/cgroup/systemd ]
+}
+
+add_privs() {
+  if ! setcap "$2" "$1" 2>/dev/null; then
+    echo "==> Warning: setcap failed, falling back to setuid root on /$1"
+    chmod u+s "$1"
+  fi
+}
+
+post_common() {
+  systemd-machine-id-setup
+
+  add_privs usr/bin/systemd-detect-virt 'cap_dac_override,cap_sys_ptrace+ep'
+
+  udevadm hwdb --update
+  journalctl --update-catalog
+
+  if sd_booted; then
+    systemctl --system daemon-reexec
+  fi
+}
+
+mask_net_naming() {
+  if [ ! -e etc/udev/rules.d/80-net-name-slot.rules ]; then
+    printf >etc/udev/rules.d/80-net-name-slot.rules '# %s\n' \
+      "This file masks persistent renaming rules for network devices. If you" \
+      "delete this file, /usr/lib/udev/rules.d/80-net-name-slot.rules may" \
+      "rename network devices according to ID_NET_NAME_{ONBOARD,SLOT,PATH}" \
+      "properties of your network devices, with priority in that order. See" \
+      "the output of 'udevadm test-builtin net_id /sys/class/net/\$interface'" \
+      "for details on what that new name might be." \
+      "" \
+      "http://www.freedesktop.org/wiki/Software/systemd/PredictableNetworkInterfaceNames"
+  fi
+}
+
+post_install() {
+  post_common
+
+  # enable getty at tty1 by default, but don't track the file
+  systemctl enable getty at .service
+
+  echo ":: Append 'init=/usr/lib/systemd/systemd' to your kernel command line in your"
+  echo "   bootloader to replace sysvinit with systemd, or install systemd-sysvcompat"
+}
+
+post_upgrade() {
+  post_common
+
+  # getty at tty1.service is no longer enabled by default, but we don't want to break
+  # existing setups.
+  if [ "$(vercmp 183 "$2")" -eq 1 ]; then
+    # systemctl seems to be whiny on sysvinit. this will succeed unless something
+    # horrific happens, so just mask the error.
+    systemctl -q enable getty at .service || true
+  fi
+
+  if [ "$(vercmp 194-4 "$2")" -eq 1 ]; then
+    printf '==> journald now writes to /var/log/journal by default. This can be\n'
+    printf '    controlled with the Storage setting in /etc/systemd/journald.conf\n'
+  fi
+
+  # logind's protocol changed. kindly restart the daemon to avoid locking
+  # out further logins.
+  if [ "$(vercmp 195 "$2")" -eq 1 ]; then
+    if sd_booted; then
+      systemctl restart systemd-logind.service
+    fi
+  fi
+
+  if [ "$(vercmp 196-1 "$2")" -eq 1 ]; then
+    printf '==> The legacy configuration options are no longer supported in rc.conf,\n'
+    printf '    convert your rc.conf to the new configuration formats.\n'
+  fi
+
+  if [ "$(vercmp 197-1 "$2")" -eq 1 ]; then
+    mask_net_naming
+    printf '==> Persistent net naming rules have been shipped as disabled.\n'
+    printf '    See /etc/udev/rules.d/80-net-name-slot.rules for more detail\n'
+  fi
+
+  if [ "$(vercmp 204-1 "$2")" -eq 1 ]; then
+    printf '==> The /bin/systemd symlink has been removed. Any references in your\n'
+    printf '    bootloader (or elsewhere) must be updated to /usr/lib/systemd/systemd.\n'
+  fi
+
+  if [ "$(vercmp 205-1 "$2")" -eq 1 ]; then
+    printf '==> systemd 205 restructures the cgroup hierarchy and changes internal\n'
+    printf '    protocols. You should reboot at your earliest convenience.\n'
+  fi
+
+  if [ "$(vercmp 206-1 "$2")" -eq 1 ]; then
+    printf '==> The "timestamp" hook for mkinitcpio no longer exists. If you used\n'
+    printf '    this hook, you must remove it from /etc/mkinitcpio.conf. A "systemd"\n'
+    printf '    hook has been added which provides this functionality, and more.\n'
+  fi
+}
+
+# vim:set ts=2 sw=2 et:




More information about the arch-commits mailing list